var game;

function Square(type, i) {
	this.point = new Array();
	this.id = i;
	this.type = type;
	
	this.show = function() {
		if (this.point[1]>=0)
			document.getElementById("b" + this.point[0] + "_" + this.point[1]).className = "b hasBlock " +type + " id_" + i; 
		//$("#b" + this.point[0] + "_" + this.point[1]).addClass("hasBlock " +type + " id_" + i);
	}
	
	this.showNext = function() {
		$("#n" + this.point[0] + "_" + this.point[1]).addClass("hasBlock " + type + " id_" + i);
	}
	
	this.showSaved = function() {
		$("#s" + this.point[0] + "_" + this.point[1]).addClass("hasBlock " + type + " id_" + i);
	}
	
	this.hide = function(){
		if ($("#b" + this.point[0] + "_" + this.point[1]).hasClass("id_" + i))
		{
			if (this.point[1]>=0)
				document.getElementById("b" + this.point[0] + "_" + this.point[1]).className = "b";
			//$("#b" + this.point[0] + "_" + this.point[1]).attr('class','b');
		}
	
	}
}

function Block(x, y, type, i) {
	this.index = i;
	var types = new Array("O","I","J","L","T","Z","S");
	this.dropper = false;
	
	if (type == "") {
		type = types[Math.floor(Math.random()*7)];
	}
	
	this.type = type;
	
	this.square1 = new Square(type, i);
	this.square2 = new Square(type, i);
	this.square3 = new Square(type, i);
	this.square4 = new Square(type, i);
	
	switch(type) {
		case "O":
			this.square1.point = new Array(x,y);
			this.square2.point = new Array(x+1,y);
			this.square3.point = new Array(x,y+1);
			this.square4.point = new Array(x+1,y+1);
			break;
		case "I":
			this.square1.point = new Array(x,y);
			this.square2.point = new Array(x,y+1);
			this.square3.point = new Array(x,y+2);
			this.square4.point = new Array(x,y+3);
			break;
		case "J":
			this.square1.point = new Array(x,y);
			this.square2.point = new Array(x,y+1);
			this.square3.point = new Array(x,y+2);
			this.square4.point = new Array(x-1,y+2);
			break;
		case "L":
			this.square1.point = new Array(x,y);
			this.square2.point = new Array(x,y+1);
			this.square3.point = new Array(x,y+2);
			this.square4.point = new Array(x+1,y+2);
			break;
		case "T":
			this.square1.point = new Array(x,y);
			this.square2.point = new Array(x+1,y);
			this.square3.point = new Array(x+2,y);
			this.square4.point = new Array(x+1,y+1);
			break;
		case "Z":
			this.square1.point = new Array(x,y);
			this.square2.point = new Array(x+1,y);
			this.square3.point = new Array(x+1,y+1);
			this.square4.point = new Array(x+2,y+1);
			break;
		case "S":
			this.square1.point = new Array(x,y);
			this.square2.point = new Array(x+1,y);
			this.square3.point = new Array(x,y+1);
			this.square4.point = new Array(x-1,y+1);
			break;
	}
	
	this.top = function() {
		return Math.min(this.square1.point[1], Math.min(this.square2.point[1], Math.min(this.square3.point[1], this.square4.point[1])))
	}
	
	this.bottom = function() {
		return Math.max(this.square1.point[1], Math.max(this.square2.point[1], Math.max(this.square3.point[1], this.square4.point[1])))
	}
	
	this.down = function() {
		if (game.isEmpty(this.square1.point[0],this.square1.point[1]+1, this.index) &&
			game.isEmpty(this.square2.point[0],this.square2.point[1]+1, this.index) &&
			game.isEmpty(this.square3.point[0],this.square3.point[1]+1, this.index) &&
			game.isEmpty(this.square4.point[0],this.square4.point[1]+1, this.index)) {
			this.hide();
			this.square1.point = new Array(this.square1.point[0],this.square1.point[1] + 1);
			this.square2.point = new Array(this.square2.point[0],this.square2.point[1] + 1);
			this.square3.point = new Array(this.square3.point[0],this.square3.point[1] + 1);
			this.square4.point = new Array(this.square4.point[0],this.square4.point[1] + 1);

			
			this.show();
			return true;
		}
		else
		{
			this.dropped = true;
			return false;
		}
	}
	
	this.drop = function() {
		
		while (game.isEmpty(this.square1.point[0],this.square1.point[1]+1, this.index) &&
			game.isEmpty(this.square2.point[0],this.square2.point[1]+1, this.index) &&
			game.isEmpty(this.square3.point[0],this.square3.point[1]+1, this.index) &&
			game.isEmpty(this.square4.point[0],this.square4.point[1]+1, this.index)) {
			this.hide();
			this.square1.point = new Array(this.square1.point[0],this.square1.point[1] + 1);
			this.square2.point = new Array(this.square2.point[0],this.square2.point[1] + 1);
			this.square3.point = new Array(this.square3.point[0],this.square3.point[1] + 1);
			this.square4.point = new Array(this.square4.point[0],this.square4.point[1] + 1);
			this.show();
		}
		
		this.dropped = true;
		
	}
	
	this.right = function(){
		if (!this.dropped) {
			if (game.isEmpty(this.square1.point[0] + 1, this.square1.point[1], this.index) &&
			game.isEmpty(this.square2.point[0] + 1, this.square2.point[1], this.index) &&
			game.isEmpty(this.square3.point[0] + 1, this.square3.point[1], this.index) &&
			game.isEmpty(this.square4.point[0] + 1, this.square4.point[1], this.index)) {
				this.hide();
				this.square1.point = new Array(this.square1.point[0] + 1, this.square1.point[1]);
				this.square2.point = new Array(this.square2.point[0] + 1, this.square2.point[1]);
				this.square3.point = new Array(this.square3.point[0] + 1, this.square3.point[1]);
				this.square4.point = new Array(this.square4.point[0] + 1, this.square4.point[1]);
				this.show();
				return true;
			}
			else {
				return false;
			}
		}
		return false;
	}
	
	this.left = function() {
		if (!this.dropped) {
			if (game.isEmpty(this.square1.point[0] - 1, this.square1.point[1], this.index) &&
			game.isEmpty(this.square2.point[0] - 1, this.square2.point[1], this.index) &&
			game.isEmpty(this.square3.point[0] - 1, this.square3.point[1], this.index) &&
			game.isEmpty(this.square4.point[0] - 1, this.square4.point[1], this.index)) {
				this.hide();
				this.square1.point = new Array(this.square1.point[0] - 1, this.square1.point[1]);
				this.square2.point = new Array(this.square2.point[0] - 1, this.square2.point[1]);
				this.square3.point = new Array(this.square3.point[0] - 1, this.square3.point[1]);
				this.square4.point = new Array(this.square4.point[0] - 1, this.square4.point[1]);
				this.show();
				return true;
			}
			else {
				return false;
			}
		}
		return false;
		
	}
	
	var statusRotation = "N";
	
	this.rotate = function() {
		
		var oldPosition1 = this.square1.point;
		var oldPosition2 = this.square2.point;
		var oldPosition3 = this.square3.point;
		var oldPosition4 = this.square4.point;
		var oldStatusRotation = statusRotation;
		
		this.hide();
		
		switch (type) {
			case "O":
				break;
			case "I":
				if (statusRotation == "N") {
					statusRotation = "E";
					this.square1.point = new Array( this.square2.point[0]-1, this.square2.point[1]);
					this.square3.point = new Array( this.square2.point[0]+1, this.square2.point[1]);
					this.square4.point = new Array( this.square2.point[0]+2, this.square2.point[1]);
				}
				else if (statusRotation == "E") {
					statusRotation = "N";
					this.square1.point = new Array( this.square2.point[0], this.square2.point[1]-1);
					this.square3.point = new Array( this.square2.point[0], this.square2.point[1]+1);
					this.square4.point = new Array( this.square2.point[0], this.square2.point[1]+2);
				}
				break;
			case "J":
				if (statusRotation == "N") {
					statusRotation = "E";
					this.square1.point = new Array( this.square2.point[0]-1, this.square2.point[1]-1);
					this.square3.point = new Array( this.square2.point[0]-1, this.square2.point[1]);
					this.square4.point = new Array( this.square2.point[0]+1, this.square2.point[1]);
				}
				else if (statusRotation == "E") {
					statusRotation = "S";
					this.square1.point = new Array( this.square2.point[0]+1, this.square2.point[1]-1);
					this.square3.point = new Array( this.square2.point[0], this.square2.point[1]+1);
					this.square4.point = new Array( this.square2.point[0], this.square2.point[1]-1);
				}
				else if (statusRotation == "S") {
					statusRotation = "W";
					this.square1.point = new Array( this.square2.point[0]+1, this.square2.point[1]);
					this.square3.point = new Array( this.square2.point[0]+1, this.square2.point[1]+1);
					this.square4.point = new Array( this.square2.point[0]-1, this.square2.point[1]);
				}
				else if (statusRotation == "W") {
					statusRotation = "N";
					this.square1.point = new Array( this.square2.point[0], this.square2.point[1]-1);
					this.square3.point = new Array( this.square2.point[0], this.square2.point[1]+1);
					this.square4.point = new Array( this.square2.point[0]-1, this.square2.point[1]+1);

				}
				break;
			case "L":
				if (statusRotation == "N") {
					statusRotation = "E";
					this.square1.point = new Array( this.square2.point[0]-1, this.square2.point[1]);
					this.square3.point = new Array( this.square2.point[0]+1, this.square2.point[1]);
					this.square4.point = new Array( this.square2.point[0]+1, this.square2.point[1]-1);
				}
				else if (statusRotation == "E") {
					statusRotation = "S";
					this.square1.point = new Array( this.square2.point[0]-1, this.square2.point[1]-1);
					this.square3.point = new Array( this.square2.point[0], this.square2.point[1]-1);
					this.square4.point = new Array( this.square2.point[0], this.square2.point[1]+1);
				}
				else if (statusRotation == "S") {
					statusRotation = "W";
					this.square1.point = new Array( this.square2.point[0]-1, this.square2.point[1]);
					this.square3.point = new Array( this.square2.point[0]-1, this.square2.point[1]+1);
					this.square4.point = new Array( this.square2.point[0]+1, this.square2.point[1]);
				}
				else if (statusRotation == "W") {
					statusRotation = "N";
					this.square1.point = new Array( this.square2.point[0], this.square2.point[1]-1);
					this.square3.point = new Array( this.square2.point[0], this.square2.point[1]+1);
					this.square4.point = new Array( this.square2.point[0]+1, this.square2.point[1]+1);

				}
				break;
			case "T":
				if (statusRotation == "N") {
					statusRotation = "E";
					this.square1.point = new Array( this.square2.point[0], this.square2.point[1]-1);
					this.square3.point = new Array( this.square2.point[0], this.square2.point[1]+1);
					this.square4.point = new Array( this.square2.point[0]-1, this.square2.point[1]);
				}
				else if (statusRotation == "E") {
					statusRotation = "S";
					this.square1.point = new Array( this.square2.point[0]+1, this.square2.point[1]);
					this.square3.point = new Array( this.square2.point[0]-1, this.square2.point[1]);
					this.square4.point = new Array( this.square2.point[0], this.square2.point[1]-1);
					
				}
				else if (statusRotation == "S") {
					statusRotation = "W";
					this.square1.point = new Array( this.square2.point[0]+1, this.square2.point[1]);
					this.square3.point = new Array( this.square2.point[0], this.square2.point[1]-1);
					this.square4.point = new Array( this.square2.point[0], this.square2.point[1]+1);
				}
				else if (statusRotation == "W") {
					statusRotation = "N";
					this.square1.point = new Array( this.square2.point[0]-1, this.square2.point[1]);
					this.square3.point = new Array( this.square2.point[0]+1, this.square2.point[1]);
					this.square4.point = new Array( this.square2.point[0], this.square2.point[1]+1);

				}
				break;
			case "Z":
				if (statusRotation == "N") {
					statusRotation = "E";
					this.square1.point = new Array( this.square2.point[0], this.square2.point[1]-1);
					this.square3.point = new Array( this.square2.point[0]-1, this.square2.point[1]);
					this.square4.point = new Array( this.square2.point[0]-1, this.square2.point[1]+1);
				}
				else if (statusRotation == "E") {
					statusRotation = "N";
					this.square1.point = new Array( this.square2.point[0]-1, this.square2.point[1]);
					this.square3.point = new Array( this.square2.point[0]+1, this.square2.point[1]+1);
					this.square4.point = new Array( this.square2.point[0], this.square2.point[1]+1);
				}
				break;
			case "S":
				if (statusRotation == "N") {
					statusRotation = "E";
					this.square2.point = new Array( this.square1.point[0], this.square1.point[1]-1);
					this.square3.point = new Array( this.square1.point[0]+1, this.square1.point[1]);
					this.square4.point = new Array( this.square1.point[0]+1, this.square1.point[1]+1);
				}
				else if (statusRotation == "E") {
					statusRotation = "N";
					this.square2.point = new Array( this.square1.point[0]+1, this.square1.point[1]);
					this.square3.point = new Array( this.square1.point[0]-1, this.square1.point[1]+1);
					this.square4.point = new Array( this.square1.point[0], this.square1.point[1]+1);
				}
				break;
		}
		
		if (!(game.isEmpty(this.square1.point[0], this.square1.point[1], this.index) &&
		game.isEmpty(this.square2.point[0], this.square2.point[1], this.index) &&
		game.isEmpty(this.square3.point[0], this.square3.point[1], this.index) &&
		game.isEmpty(this.square4.point[0], this.square4.point[1], this.index)))
		{
			statusRotation = oldStatusRotation;
			this.square1.point = oldPosition1;
			this.square2.point = oldPosition2;
			this.square3.point = oldPosition3;
			this.square4.point = oldPosition4;
		}
		
		this.show();
	}
	
	this.showSaved = function() {
		$("#saved-block div.hasBlock").removeClass().addClass('b');
		this.square1.showSaved();
		this.square2.showSaved();
		this.square3.showSaved();
		this.square4.showSaved();
	}
	
	this.show = function() {
		this.square1.show();
		this.square2.show();
		this.square3.show();
		this.square4.show();
				
	}
	
	this.showNext = function() {
		$("#next-block div.hasBlock").removeClass().addClass('b');
		this.square1.showNext();
		this.square2.showNext();
		this.square3.showNext();
		this.square4.showNext();
	}
	
	this.hide = function() {
		this.square1.hide();
		this.square2.hide();
		this.square3.hide();
		this.square4.hide();		
	}
	

}

function GameField() {
	
	this.backColor = "#000000";
	this.width = 12;
	this.height = 20;
	
	game = this;
	
	this.isEmpty = function(x,y,i) {
		//Out of the bounds
		if (y >= this.height || x < 0 || x >= this.width) {
			return false
		}
		
		if ($("#b" + x + "_" + y).hasClass("hasBlock") && !( $("#b" + x + "_" + y).hasClass("id_" + i))) {
			return false
		}
			
		return true;
	}
	
	this.checkLines = function(top, bottom) {
		var checklines_result = 0;
		for (top;top<=bottom;top++) {
			//for (var i = 0; i < this.width; i++) {
				if ($("div[id$='_" + top + "'].hasBlock").size() < this.width) {
					continue;
				}
				else {
					checklines_result++;
					$("div[id$='_" + top + "'].hasBlock").removeClass().addClass("b");
					if (top != 0) {
						for (move = top; move >0; move--) {
							for (var i = 0; i < this.width; i++)
							{
								$("#b" + i + "_" + move).removeClass();
								$("#b" + i + "_" + move).attr('class', $("#b" + i + "_" + (move-1)).attr('class'));
							}
							
							if ($("div[id$='_" + move + "'].hasBlock").size() == 0) {
								break;
							}
						}
					}
					else {
						$("div[id$='_0']").removeClass().addClass("b");
					}
				}
			//}			
			
		}
		
		return checklines_result;
	}

}