var width;
var game;
var high_score = 0;
var score = 0;
var level;
var currentBlock;
var nextBlock;
var savedBlock;
var blockSaved = false;
var paused = false;

$( function() {
	$("*").keydown(function(event) {
	   switch(event.keyCode)
	   {
	   	  case 32:
		  	  currentBlock.drop();
			  break;
	      case 37:
		      currentBlock.left();
		      break;
		  case 38:
		      currentBlock.rotate();
		      break;
	      case 39:
	   	      currentBlock.right();
		      break;
	      case 40:
	   	      currentBlock.down();
		      break;
	   }
	
	});
});

function resizeUI() {
	var height = $(window).height();
	width = $(window).width();
	if(width>height) {
		isLandscape = true;
	} else {
		// Portrait
		isLandscape = false;		
	}	
}

function bind_buttons() {
	$("#levels span").mousedown( function() {
		$("#levels span").removeClass();
		$(this).addClass("level ui-corner-all");
	});
	
	$("#new-game-button").mousedown(function(){
		$("#new-game").show();
		pause_game();
		return false;
	});
	
	$("#cancel-game-button").mousedown(function(){
		$("#new-game").hide();
		pause_game();
		return false;
	});
	
	$("#start-game-button").mousedown(function(){
		$("#new-game").hide();
		pause_game();
		reset_game($("#levels .level").text());
		return false;
	});
	
	$("#pause-game-button").mousedown(function(){
		pause_game();
		return false;
	});
	
	$("#exit-game-button").click(function(){
		window.close();
	});
	
	$("#left-button").mousedown(function(){
		if (!paused)
			currentBlock.left();
		return false;
	});
	
	$("#right-button").mousedown(function(){
		if (!paused)
			currentBlock.right();
		return false;			
	});
	
	$("#down-button").mousedown(function(){
		if (!paused)
			currentBlock.down();
		return false;			
	});
	
	$("#drop-button").mousedown(function(){
		if (!paused)
			currentBlock.drop();
		return false;			
	});
	
	$("#rotate-button").mousedown(function(){
		if (!paused)
			currentBlock.rotate();
		return false;		
	});
	
	
	$("#saved-block").mousedown(function(){
		if (!paused && !blockSaved) {
			if (savedBlock == null) {
				savedBlock = new Block(1, 0, currentBlock.type, index++);
				savedBlock.showSaved();
				currentBlock.hide();
				currentBlock = new Block(5, -3, nextBlock.type, nextBlock.index);
				currentBlock.show();
				
				nextBlock = new Block(1, 0, "", index++)
				nextBlock.showNext();
			}
			else {
				var type = currentBlock.type;
				currentBlock.hide();
				currentBlock = new Block(5, -3, savedBlock.type, savedBlock.index);
				currentBlock.show();
				savedBlock = new Block(1, 0, type, index++);
				savedBlock.showSaved();
			}
			blockSaved = true;
		}
		return false;		
	});

}

function init() {
	if (window.widget) {
		if (widget.isrotationsupported) {
			widget.setDisplayPortrait();
		}
		high_score = window.widget.preferenceForKey('highScore');
	}
	
	window.menu.hideSoftkeys();
	document.body.style.webkitUserSelect = "none";
	if(high_score==null) {
		high_score = 0;
	}
	bind_buttons();
	draw_board();
	$("#new-game").show();
}

function pause_game() {
	if (timer_is_on) {
		if (paused) {
			paused = false;
			$("#game-paused").hide();
			play();
		}
		else {
			paused = true;
			$("#game-paused").show();
		}
	}
}

function draw_board() {
	var blocks = 0;
	var new_html = "";
	var lastBlock = -1;
	var gameOver = true;
	for(var j=0;j<20;j++) {
		for(var i=0;i<12;i++) {
			new_html += "<div id='b" + i + "_" + j + "' class='b'/>";
		}
	}
	$("#board").html(new_html);
	return blocks;
}
function reset_game(level) {
	game = new GameField();
	score=0;
	this.level=level;
	paused = false;
	blockSaved = false;
	$("#game-over").hide();
	$("#game-paused").hide();
	draw_stat();
	$("#board div").removeClass().addClass('b');
	$("#saved-block div.hasBlock").removeClass().addClass('b');
	savedBlock = null;
	currentBlock = new Block(5,-3,"", index++)
	currentBlock.show();
	nextBlock = new Block(1,0,"",index++);
	nextBlock.showNext();
	startGameLoop();
}

function draw_stat() {
	$("#score").text(score);
	$("#level").text(level);
	if(score>high_score) {
		high_score = score;
		if (window.widget) {
			window.widget.setPreferenceForKey(high_score, 'highScore');
		}
			
		
	}
	$("#high_score").text(high_score);
}

var c=0;
var t;
var timer_is_on=0;
var erasedLines;
var levelLines = 0;
var stillProcessing = false;
var index = 0;

function play(){

	if (!paused) {
		var multiplier = level;
		if (level > 9) 
			multiplier = 9;
		
		timeout = 1000 - 99 * multiplier;
		
		if (stillProcessing) {
			var t = setTimeout("play()", timeout);
			return;
		}
		
		stillProcessing = true;
		
		if (!currentBlock.down()) {
			if (currentBlock.dropped && currentBlock.top() <= 0) {
				$("#game-over").show();
				stillProcessing = false;
				timer_is_on = 0;
				return;
			}
			
			erasedLines = game.checkLines(currentBlock.top(), currentBlock.bottom());
			if (erasedLines > 0) {
				score += 100 + ((erasedLines - 1) * 150) + (level * erasedLines * 15);
				levelLines += erasedLines;
				if (levelLines > (level + 1) * 10) {
					levelLines = 0;
					level++;
				}
				
				draw_stat();
			}
			
			currentBlock = new Block(5, -3, nextBlock.type, nextBlock.index);
			currentBlock.show();
			
			nextBlock = new Block(1, 0, "", index++)
			nextBlock.showNext();
			if (index > 10000) 
				index = 0;
			
			blockSaved = false;
		}
		stillProcessing = false;
		var t = setTimeout("play()", timeout);
	}
}

function startGameLoop()
{
if (!timer_is_on)
  {
  timer_is_on=1;
  play();
  }
}
